/*
 * poli.h
 */

#ifndef POLI
#define POLI

typedef struct termo *ap_poli;
 
struct termo {
  float coef;
  int expo;
  ap_poli prox;
};

/* Cria um polinomio formado por um nico termo de coeficiente coef
   e expoente expo. */
ap_poli cria_termo(float coef, int expo); 

/* Soma os polinmios apontados por p e q, sem destru-los e retorna
   o resultado. */
ap_poli soma(ap_poli p, ap_poli q);

/* Multiplica o polinmio p por um escalar, sem destru-lo, e retorna o
   polinmio resultante. */
ap_poli mult_escalar(ap_poli p, float escalar);

/* Subtrai q de p e retorna o polinmio resultante. As funes 
   multEscalar e soma podem ser utilizadas para fazer a subtrao. */
ap_poli subtrai(ap_poli p, ap_poli q);

/* Multiplica os polinmios apontados por p e q, sem destru-los, e 
   retorna o resultado. Os ns intermedirios, criados durante o
   processo, devem ser destrudos. */
ap_poli multiplica(ap_poli p, ap_poli q);
 
/* Retorna uma cpia do polinmio p. A funo multEscalar pode ser
   utilizada para fazer a cpia. */
ap_poli copia(ap_poli p);

/* Desaloca a memria correspondente ao polinmio p. */
void libera(ap_poli p);

/* Escreve o polinmio apontado por p */
void escreve(ap_poli p);

#endif
